'use strict';

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _webpack3 = require('./webpack.config');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Created by Zhengfeng.Yao on 16/9/22.
 */
module.exports = function bundle(options) {
  return new Promise(function (resolve, reject) {
    var webpackConfig = (0, _webpack3.getWebpackConfig)(options);
    var finished = function finished(err, stats) {
      if (err) {
        console.log(err);
        return reject(err);
      }

      console.log(stats.toString(webpackConfig[0].stats));
      return resolve();
    };
    if (options.watch) {
      (0, _webpack2.default)(webpackConfig).watch({}, finished);
    } else {
      (0, _webpack2.default)(webpackConfig).run(finished);
    }
  });
};