'use strict';

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _server = require('karma/lib/server');

var _server2 = _interopRequireDefault(_server);

var _open = require('open');

var _open2 = _interopRequireDefault(_open);

var _utils = require('./utils');

var _webpackConfig = require('./webpack.config.test');

var _webpackConfig2 = _interopRequireDefault(_webpackConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * Created by Zhengfeng.Yao on 16/9/23.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            */


var cwd = process.cwd();

function openReportOnBrowser(output) {
  (0, _open2.default)('file://' + _path2.default.join(cwd, output, 'html', 'index.html'));
}

module.exports = function () {
  var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(options) {
    var aegisConfig, files, output, watch, verbose, port, webpackConfig, configFile, plugins, opts, server;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            process.env.NODE_ENV = 'test';
            aegisConfig = (0, _utils.loadAegisConfig)('.test');
            files = aegisConfig.files, output = aegisConfig.output;
            watch = options.watch, verbose = options.verbose, port = options.port;
            webpackConfig = (0, _webpackConfig2.default)(options);
            configFile = _path2.default.join(__dirname, 'karma.conf.js');
            plugins = ['webpack', 'sourcemap'];
            opts = {
              basePath: _path2.default.resolve(cwd, '.'),
              configFile: configFile,
              singleRun: !watch,
              autoWatch: !!watch,
              port: port || 8080,
              webpack: webpackConfig,
              files: files,
              preprocessors: files.map(function (file) {
                return file;
              }).reduce(function (result, file) {
                result[file] = plugins;
                return result;
              }, {}),
              reporters: ['mocha', 'coverage'].filter(_utils.isValid),
              coverageReporter: {
                dir: output,
                reporters: [{ type: 'json', subdir: './json' }, { type: 'html', subdir: './html' }]
              },
              logLevel: '' + (!!verbose ? 'debug' : 'info')
            };

            if (watch) {
              _context.next = 13;
              break;
            }

            _context.next = 11;
            return new Promise(function (resolve) {
              _server2.default.start(opts, function () {
                openReportOnBrowser(output);
                resolve();
              });
            });

          case 11:
            _context.next = 17;
            break;

          case 13:
            server = new _server2.default(opts);

            server.on('run_complete', function () {
              openReportOnBrowser(output);
            });
            _context.next = 17;
            return server.start();

          case 17:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  function test(_x) {
    return _ref.apply(this, arguments);
  }

  return test;
}();