'use strict';

var _utils = require('./utils');

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                             * Created by Zhengfeng Yao on 16/9/21.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                             */


function transform(entries, f) {
  var dirty = false;
  entries.forEach(function (entry) {
    if (entry) {
      Object.keys(entry).forEach(function (key) {
        var value = entry[key];
        var n = f(key, value);
        if (n && n !== value) {
          entry[key] = n;
          console.log(key + ' ' + n);
          dirty = true;
        }
      });
    }
  });
  return dirty;
}

exports.freeze = function () {
  var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee() {
    var cwd, pkg, dirty;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            cwd = process.cwd();
            pkg = (0, _utils.loadPackage)(cwd);
            dirty = transform([pkg.dependencies, pkg.devDependencies], function (name, version) {
              var mo = version.match(/^(?:[\^|\~])|(?:\>=?\s*)/);
              if (mo) {
                return version.slice(mo[0].length);
              }
            });

            if (dirty) {
              (0, _utils.savePackage)(pkg);
            }
            _context.next = 6;
            return dirty;

          case 6:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  function freeze() {
    return _ref.apply(this, arguments);
  }

  return freeze;
}();

exports.unfreeze = function () {
  var _ref2 = _asyncToGenerator(regeneratorRuntime.mark(function _callee2(options) {
    var config, pkg, locked, prefix, dirty;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            config = (0, _utils.loadAegisConfig)();
            pkg = (0, _utils.loadPackage)();
            locked = {};

            (config.locked || []).forEach(function (name) {
              locked[name] = true;
            });
            prefix = options.aggresive ? '>=' : '^';
            dirty = transform([pkg.dependencies, pkg.devDependencies], function (name, value) {
              if (!locked[name] && /^\d{1,3}\.\d{1,3}\.\d{1,3}$/.test(value)) {
                return prefix + value;
              }
            });

            if (dirty) {
              (0, _utils.savePackage)(pkg);
            }
            _context2.next = 9;
            return dirty;

          case 9:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  function unfreeze(_x) {
    return _ref2.apply(this, arguments);
  }

  return unfreeze;
}();