'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isValid = isValid;
exports.loadPackage = loadPackage;
exports.savePackage = savePackage;
exports.loadAegisConfig = loadAegisConfig;
exports.makeDir = makeDir;

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _mkdirp = require('mkdirp');

var _mkdirp2 = _interopRequireDefault(_mkdirp);

var _babel = require('./babel.config');

var _babel2 = _interopRequireDefault(_babel);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Created by Zhengfeng Yao on 16/9/21.
 */
var cwd = process.cwd();

function isValid(x) {
  return !!x;
}

function loadPackage() {
  return require(_path2.default.resolve(cwd, 'package.json'));
}

function savePackage(pkg) {
  var fn = _path2.default.join(cwd, 'package.json');
  _fs2.default.writeFileSync(fn, JSON.stringify(pkg, null, ' '), { encoding: 'utf8' });
}

function loadAegisConfig(prefix) {
  try {
    require('babel-register')((0, _babel2.default)());
    return require(_path2.default.resolve(cwd, 'aegis.config' + (prefix || '')));
  } catch (_) {
    console.log(_);
    return {};
  }
}

function makeDir(name) {
  return new Promise(function (resolve, reject) {
    (0, _mkdirp2.default)(name, function (err) {
      return err ? reject(err) : resolve();
    });
  });
}