'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getTestWebpackConfig;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _babel = require('./babel.config');

var _babel2 = _interopRequireDefault(_babel);

var _webpackMerge = require('webpack-merge');

var _webpackMerge2 = _interopRequireDefault(_webpackMerge);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } } /**
                                                                                                                                                                                                     * Created by Zhengfeng.Yao on 16/9/23.
                                                                                                                                                                                                     */


var cwd = process.cwd();

function resolvePaths(input) {
  if (input) {
    if (typeof input == 'string') {
      return [_path2.default.join(cwd, input)];
    }

    if (Array.isArray(input)) {
      return input.map(function (src) {
        return _path2.default.join(cwd, src);
      });
    }
  }

  return [];
}

function getTestWebpackConfig(options) {
  var config = (0, _utils.loadAegisConfig)('.test');
  var src = config.src,
      testPath = config.testPath;

  return (0, _webpackMerge2.default)({
    devtool: 'inline-source-map',

    resolve: {
      root: _path2.default.resolve(cwd, '.'),
      extensions: ['', '.webpack.js', '.web.js', '.js', '.jsx', '.json'],
      modulesDirectories: ['node_modules', _path2.default.join(cwd, 'node_modules'), _path2.default.join(__dirname, '../node_modules')]
    },

    resolveLoader: {
      modulesDirectories: ['node_modules', _path2.default.join(cwd, 'node_modules'), _path2.default.join(__dirname, '../node_modules')]
    },

    babel: (0, _babel2.default)(),
    isparta: {
      embedSource: true,
      noAutoWrap: true,
      babel: (0, _babel2.default)()
    },

    module: {
      loaders: [{
        test: /\.jsx?$/,
        include: [].concat(_toConsumableArray(resolvePaths(src)), _toConsumableArray(resolvePaths(testPath))).filter(_utils.isValid),
        exclude: /\.es5\.js$/,
        loader: 'babel-loader'
      }, {
        test: /\.est$/,
        loader: 'babel-loader!template-string-loader'
      }, {
        test: /\.json$/,
        loader: 'json-loader'
      }, {
        test: /\.json5$/,
        loader: 'json5-loader'
      }, {
        test: /\.(woff\d?|ttf|eot|svg|jpe?g|png|gif|txt|css|less|sass|scss|styl)(\?.*)?$/,
        loader: 'null-loader'
      }].filter(_utils.isValid),
      preLoaders: [{
        test: /\.(js|jsx)$/,
        loader: 'isparta',
        include: resolvePaths(src)
      }]
    }
  }, config.webpack);
};
module.exports = exports['default'];