'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _open = require('open');

var _open2 = _interopRequireDefault(_open);

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _webpackDevServer = require('webpack-dev-server');

var _webpackDevServer2 = _interopRequireDefault(_webpackDevServer);

var _webpack3 = require('./webpack.config');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } } /**
                                                                                                                                                                                                     * Created by Zhengfeng.Yao on 16/9/22.
                                                                                                                                                                                                     */


var cwd = process.cwd();

function addHot(config) {
  if (Array.isArray(config.entry)) {
    config.entry.unshift('webpack-dev-server/client?http://localhost:' + config.port);
  } else if (config.entry.constructor == Object) {
    Object.keys(config.entry).forEach(function (key) {
      if (Array.isArray(config.entry[key])) {
        config.entry[key].unshift('webpack-dev-server/client?http://localhost:' + config.port, "webpack/hot/dev-server");
      } else {
        config.entry[key] = ['webpack-dev-server/client?http://localhost:' + config.port, "webpack/hot/dev-server", config.entry[key]];
      }
    });
  } else {
    config.entry = ['webpack-dev-server/client?http://localhost:' + config.port, "webpack/hot/dev-server", config.entry];
  }

  config.plugins.push(new _webpack2.default.HotModuleReplacementPlugin());
  config.plugins.push(new _webpack2.default.NoErrorsPlugin());
  config.module.loaders.filter(function (x) {
    return x.loader.indexOf('babel') !== -1;
  }).forEach(function (x) {
    return x.query = {
      plugins: [].concat(_toConsumableArray(config.babel.plugins), [[require.resolve('babel-plugin-react-transform'), {
        transforms: [{
          transform: 'react-transform-hmr',
          imports: ['react'],
          locals: ['module']
        }, {
          transform: 'react-transform-catch-errors',
          imports: ['react', 'redbox-react']
        }]
      }]])
    };
  });
}

function getPublicPath(config) {
  var base = _path2.default.resolve(cwd, config.output.path);
  var parent = _path2.default.resolve(base, '..');
  var sub = parent == cwd ? '/' : base.substring(parent.length);
  return 'http://localhost:' + config.port + sub;
}

var WebpackDevServer = function () {
  function WebpackDevServer(options) {
    _classCallCheck(this, WebpackDevServer);

    this.config = (0, _webpack3.getWebpackConfig)(options)[0];
    this.config.port = this.config.port || 9090;
    this.config.output.publicPath = getPublicPath(this.config);
    var base = _path2.default.join(cwd, this.config.output.path);
    this.config.devServer = Object.assign({
      contentBase: base,
      historyApiFallback: true,
      hot: true
    }, this.config.devServer);
    this.config.output.path = base;
    addHot(this.config);
  }

  WebpackDevServer.prototype.run = function run() {
    var _this = this;

    new _webpackDevServer2.default((0, _webpack2.default)(this.config), this.config.devServer).listen(this.config.port, 'localhost', function (err) {
      if (err) {
        console.log(err);
      }
      console.log('The server is running at http://localhost:' + _this.config.port + '/webpack-dev-server/');
      (0, _open2.default)('http://localhost:' + _this.config.port + '/webpack-dev-server/');
    });
  };

  return WebpackDevServer;
}();

exports.default = WebpackDevServer;
module.exports = exports['default'];